// Copyright 2019 getensh.cc. All rights reserved.
// Use of this source code is governed by getensh.cc.

// package error code define
package errors

import "adm-ads/common.in/jsonrpc2"

var (
	// 通用错误
	SystemError                     = jsonrpc2.NewJsonError(10001, "系统错误")
	ServiceError                    = jsonrpc2.NewJsonError(10002, "内部服务错误")
	NoAuthAccess                    = jsonrpc2.NewJsonError(10003, "无访问权限")
	IpNoAuthAccess                  = jsonrpc2.NewJsonError(10004, "IP无访问权限")
	CheckApiNotExist                = jsonrpc2.NewJsonError(10005, "该API不存在")
	CheckMerchantNotExist           = jsonrpc2.NewJsonError(10006, "AppKey错误")
	CheckApiInfoNotExist            = jsonrpc2.NewJsonError(10007, "商户未购买该API")
	CheckSignFailed                 = jsonrpc2.NewJsonError(10008, "签名验证失败")
	CheckDecryptFailed              = jsonrpc2.NewJsonError(10009, "解密参数失败")
	CheckApiNotEnable               = jsonrpc2.NewJsonError(10010, "API未启用")
	CheckApiDayCountLimit           = jsonrpc2.NewJsonError(10011, "API 达到当日上限")
	CheckApiDaysLimit               = jsonrpc2.NewJsonError(10012, "API 已过有效期")
	CheckApiTotalCountLimit         = jsonrpc2.NewJsonError(10013, "API 达到总次数上限")
	CheckApiParamConfParseFailed    = jsonrpc2.NewJsonError(10014, "参数配置解析失败")
	CheckApiProviderConfParseFailed = jsonrpc2.NewJsonError(10015, "数据源配置解析失败")
	CheckParamShouldDecrypt         = jsonrpc2.NewJsonError(10016, "参数不应加密")
	CheckParamShouldEncrypt         = jsonrpc2.NewJsonError(10017, "参数应加密")
	ApiTimeOut                      = jsonrpc2.NewJsonError(10020, "接口响应超时")
	// 业务错误 -00 通用
	NoRecord    = jsonrpc2.NewJsonError(20001, "查无记录")
	VendorError = jsonrpc2.NewJsonError(20002, "第三方发生错误")

	// 业务错误 --平台错误（无效）
	BadParaFormat = jsonrpc2.NewJsonError(20003, "请求参数格式不对")
	ArgsError     = jsonrpc2.NewJsonError(20004, "参数错误")

	// 业务错误 --平台错误（有效）
	DataBaseError                              = jsonrpc2.NewJsonError(20005, "数据库操作失败")
	ProviderApiNotFound                        = jsonrpc2.NewJsonError(20006, "未找到数据源")
	ProviderUnavailable                        = jsonrpc2.NewJsonError(20007, "数据源不可用")
	VinPlateError                              = jsonrpc2.NewJsonError(20008, "车架号和车牌号码不匹配")
	OrderNotExist                              = jsonrpc2.NewJsonError(20009, "订单不存在")
	OrderCreateFailed                          = jsonrpc2.NewJsonError(20010, "订单创建失败")
	OrderExistError                            = jsonrpc2.NewJsonError(20011, "不能重复创建订单")
	OrderStateCanNotBeChange                   = jsonrpc2.NewJsonError(20012, "该订单状态不能被修改")
	OrderStatusNotSupported                    = jsonrpc2.NewJsonError(20013, "不支持的订单状态")
	NotSupportArea                             = jsonrpc2.NewJsonError(20014, "该地区不支持查询")
	DriverLicenseAndNameNotMatch               = jsonrpc2.NewJsonError(20015, "驾驶证和驾驶人不匹配")
	OrderParseTimeFailed                       = jsonrpc2.NewJsonError(20016, "时间格式解析错误，正确时间格式为 2006-01-02 15:04:05")
	OrderWrongTime                             = jsonrpc2.NewJsonError(20017, "不能预约该时段,预约时间为未来7天 9:00至18:00，节假日和周日不办理")
	ServiceNotSupport                          = jsonrpc2.NewJsonError(20018, "不支持的服务类型")
	VehicleNotBeUncheckInspectionTypeFailed    = jsonrpc2.NewJsonError(20019, "无法免检年审，车辆性质或类型不匹配")
	VehicleNotBeUncheckInspectionSeatFailed    = jsonrpc2.NewJsonError(20020, "无法免检年审，车座数不能大于7")
	RegDateParseFailed                         = jsonrpc2.NewJsonError(20021, "初登日期解析失败")
	VehicleNotBeUncheckInspectionRegDateFailed = jsonrpc2.NewJsonError(20022, "无法免检年审，初登日期不能在2010年9月1日之前")
	CityIdNotExist                             = jsonrpc2.NewJsonError(20023, "未找到城市ID")
	OrderNoGernerateFailed                     = jsonrpc2.NewJsonError(20024, "订单号生产失败")
	TimeCalcFailed                             = jsonrpc2.NewJsonError(20025, "时间计算错误")
	VehicleNoPlateNo                           = jsonrpc2.NewJsonError(20026, "暂未上牌")
	DataError                                  = jsonrpc2.NewJsonError(20027, "数据异常")
	AnnualInspectionUnsupportVehicle           = jsonrpc2.NewJsonError(20028, "该车辆种类不支持年检时间查询")
	TemporarilyDissupport                      = jsonrpc2.NewJsonError(20029, "暂不支持查询")
	NoRecordMustSelect                         = jsonrpc2.NewJsonError(20030, "查无记录，必选项为空")
	NoRecordProviderLimit                      = jsonrpc2.NewJsonError(20031, "查无记录，数据源达到上限")
	NoRecordProviderError                      = jsonrpc2.NewJsonError(20032, "查无记录，数据源最后一步异常")
	NoRecordDataError                          = jsonrpc2.NewJsonError(20033, "查无记录，数据异常")
	// 业务错误-02 vehicle
	NoAuthQuery             = jsonrpc2.NewJsonError(20201, "无权查询非川牌车辆")
	PlateNoError            = jsonrpc2.NewJsonError(20202, "号牌号码错误")
	ProvinceError           = jsonrpc2.NewJsonError(20203, "省份错误")
	PlateTypeNotExist       = jsonrpc2.NewJsonError(20204, "不存在的号牌种类")
	PlateOrVehicleTypeError = jsonrpc2.NewJsonError(20205, "车牌号码与车牌种类不匹配")
	QueryError              = jsonrpc2.NewJsonError(20344, "查询错误")
	VehicleInfoQuery        = jsonrpc2.NewJsonError(20206, "车辆数据查询中，请稍后获取结果")
	MoreStyle               = jsonrpc2.NewJsonError(20207, "无法唯一定型")
)
