// Copyright 2019 getensh.com. All rights reserved.
// Use of this source code is governed by getensh.com.

package handle

import (
	"adm-ads/apis"
	"adm-ads/consts"
	"adm-ads/impl/task"
)

// 处理函数的声明
type Handler func(*apis.AdsMessage) error

type DwsTask struct {
	Function         Handler  `json:"function"`     //任务处理函数
	OutputSourceCode string   `json:"source_code"`  // 任务输出源编码
	PrimaryKeys      []string `json:"primary_keys"` // 任务输出主键
}

// 声明任务
var taskMap = map[int32]DwsTask{
	20001: {task.Task1, consts.SOURCEADS1, []string{"plate_no", "plate_type"}},
	//20002:{task.Task2,consts.SOURCEADS2,[]string{"plate_no","plate_type"}},
	20003: {task.Task3, consts.SOURCEADS3, []string{"plate_no", "plate_type"}},
	//20004:{task.Task4,consts.SOURCEADS4,[]string{"plate_no","plate_type"}},
	20008: {task.Task8, consts.SOURCEADS8, []string{"vin"}},
	20009: {task.Task9, consts.SOURCEADS9, []string{"vin"}},
	20010: {task.Task10, consts.SOURCEADS10, []string{"vin"}},
	20011: {task.Task11, consts.SOURCEADS11, []string{"thrid_style_id"}},
	20014: {task.Task14, consts.SOURCEADS14, []string{"style_id"}},
	20015: {task.Task15, consts.SOURCEADS15, []string{"vin"}},
	20016: {task.Task16, consts.SOURCEADS16, []string{"vin"}},
	20017: {task.Task17, consts.SOURCEADS17, []string{"vin"}},
	20018: {task.Task18, consts.SOURCEADS18, nil},
	20019: {task.Task19, consts.SOURCEADS19, nil},
	20020: {task.Task20, consts.SOURCEADS20, []string{"id_card"}},
	20021: {task.Task21, consts.SOURCEADS21, nil},
	20023: {task.Task23, consts.SOURCEADS23, []string{"vin"}},
}
